import { ExtractExpr, TreeNodeLike } from './interfaces';
export declare class TreeNode<K = any, T = any> implements TreeNodeLike<K, T> {
    readonly key: K;
    data?: T;
    static invertTree<K, T>(treeList: Iterable<TreeNode<K, T>>, maxDepth?: number): TreeNode<K, T>[];
    static treeFromList<K, T>(list: T[], keyExpr: ExtractExpr<T, K>, parentKeyExpr: ExtractExpr<T, K>): TreeNode<K, T>[];
    static parseTree<K, T>(tree: TreeNodeLike<K, T>[]): TreeNode<K, T>[];
    private _parent;
    get parent(): TreeNode<K, T>;
    set parent(value: TreeNode<K, T>);
    get root(): TreeNode<K, T>;
    private _children;
    get children(): ReadonlyArray<TreeNode<K, T>>;
    get hasChildren(): boolean;
    constructor(key: K, data?: T);
    containsChild(key: K, maxDepth?: number): boolean;
    getChildNode(key: K, maxDepth?: number): TreeNode<K, T>;
    addChildByParent(parentKey: K, key: K, data: T): TreeNode<K, T>;
    addChild(key: K, data: T): TreeNode<K, T>;
    removeChild(key: K): T;
    removeChildNode(child: TreeNode<K, T>): TreeNode<K, T>;
    addChildNodeByParentKey(parentKey: K, child: TreeNode<K, T>): TreeNode<K, T>;
    addChildNode(child: TreeNode<K, T>): TreeNode<K, T>;
    removeChildren(keys: K[]): void;
    toList(maxDepth?: number): TreeNode<K, T>[];
    toJSON(): TreeNodeLike<K, T>;
}
//# sourceMappingURL=tree-node.d.ts.map